## glmark2 10.07.1

=== wscript ===
import commands
import subprocess
import os
import Options
import Scripting

blddir = 'build'

top = '.'
VERSION = '10.07.1'
APPNAME = 'glmark2'

# Produce '.tar.gz' with ./waf dist
Scripting.g_gz = 'gz'

def conf_message(conf, first, second):
	conf.check_message_1(first)
	conf.check_message_2(second, color='PINK')

def set_options(opt):
	opt.tool_options('compiler_cc')
	opt.tool_options('compiler_cxx')

	opt.add_option('--gl', action='store_true', dest = 'gl', default = False, help='build using OpenGL 2.0')
	opt.add_option('--glesv2', action='store_true', dest = 'glesv2', default = False, help='build using OpenGL ES 2.0')
	opt.add_option('--no-debug', action='store_false', dest = 'debug', default = True, help='disable compiler debug information')
	opt.add_option('--no-opt', action='store_false', dest = 'opt', default = True, help='disable compiler optimizations')
	opt.add_option('--data-path', action='store', dest = 'data_path', help='the path to install the data to')

def configure(conf):
	if not Options.options.gl and not Options.options.glesv2:
		conf.fatal("You must configure using at least one of --gl, --glesv2")

	conf.check_tool('compiler_cc')
	conf.check_tool('compiler_cxx')

	# Check required headers
	req_headers = ['stdlib.h', 'string.h', 'unistd.h', 'fcntl.h']
	for header in req_headers:
		conf.check_cxx(header_name = header, mandatory = True)
		
	# Check for required libs
	req_libs = [('m', 'm')]
	for (lib, uselib) in req_libs:
		conf.check_cxx(lib = lib, uselib_store = uselib)

	# Check required functions
	req_funcs = [('memset', 'string.h', []) ,('sqrt', 'math.h', ['m'])]
	for func, header, uselib in req_funcs:
		conf.check_cxx(function_name = func, header_name = header, uselib = uselib, mandatory = True)
		
	# Check required packages
	req_pkgs = [('sdl', 'sdl')]
	for (pkg, uselib) in req_pkgs:
		conf.check_cfg(package = pkg, uselib_store = uselib, args = '--cflags --libs',
				mandatory = True)
				
	# Check optional packages
	opt_pkgs = [('gl', 'gl', Options.options.gl), ('egl', 'egl', Options.options.glesv2),
			('glesv2', 'glesv2', Options.options.glesv2)]
	for (pkg, uselib, mandatory) in opt_pkgs:
		conf.check_cfg(package = pkg, uselib_store = uselib, args = '--cflags --libs',
				mandatory = mandatory)

	conf.env.append_unique('CXXFLAGS', '-Wall -Wextra -fms-extensions'.split(' '))

	# Prepend -O# and -g flags so that they can be overriden by the CFLAGS environment variable
	if Options.options.opt:
		conf.env.prepend_value('CXXFLAGS', '-O2')
	if Options.options.debug:
		conf.env.prepend_value('CXXFLAGS', '-g')

	if Options.options.data_path is None:
		Options.options.data_path = os.path.join(conf.env.PREFIX, 'share/glmark2')

	conf.env.append_unique('GLMARK_DATA_PATH', Options.options.data_path)
	conf.env.append_unique('CXXDEFINES', 'GLMARK_DATA_PATH="%s"' % Options.options.data_path)
	conf.env.append_unique('CXXDEFINES', 'GLMARK_VERSION="%s"' % VERSION)

	conf.env.USE_GL = Options.options.gl
	conf.env.USE_GLESv2 = Options.options.glesv2

	conf_message(conf, "Prefix", conf.env.PREFIX)
	conf_message(conf, "Data path", Options.options.data_path)
	conf_message(conf, "Building GL2 version", "Yes" if conf.env.USE_GL else "No")
	conf_message(conf, "Building GLESv2 version", "Yes" if conf.env.USE_GLESv2 else "No")

def build(bld):
	bld.recurse('src')
	bld.recurse('data')
	bld.recurse('doc')

=== debian/changelog ===
glmark2 (10.07.1-0ubuntu1) maverick; urgency=low

  * Initial release for linaro/maverick (LP: #605901)
    - see: https://blueprints.launchpad.net/ubuntu/+spec/arm-m-ui-and-test-heads

 -- Alexandros Frantzis <alexandros.frantzis@linaro.org>  Wed, 28 Jul 2010 18:22:35 +0300

=== debian/control ===
Source: glmark2
Section: misc
Priority: optional
Maintainer: Linaro User Platforms <linaro-dev@lists.linaro.org>
Build-Depends: debhelper (>= 7.0.50~),
               python2.4 | python2.5 | python2.6 | python2.7,
               libsdl1.2-dev,
               libgl1-mesa-dev | libgl1-dev,
               libegl1-mesa-dev | libegl1-dev,
               libgles2-mesa-dev | libgles2-dev
Standards-Version: 3.9.1
Homepage: https://launchpad.net/glmark2

Package: glmark2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         glmark2-data (= ${source:Version})
Description: OpenGL (ES) 2.0 benchmark
 A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
 API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
 arrays, VBOs, texturing and shaders.
 .
 This package contains the OpenGL 2.0 variant of the benchmark.

Package: glmark2-es2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         glmark2-data (= ${source:Version})
Description: OpenGL (ES) 2.0 benchmark
 A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
 API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
 arrays, VBOs, texturing and shaders.
 .
 This package contains the OpenGL ES 2.0 variant of the benchmark.

Package: glmark2-data
Architecture: all
Depends: ${misc:Depends}
Description: Data files for the glmark2 OpenGL (ES) 2.0 benchmark
 This package contains the data files used by the glmark2 benchmark.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@ 

override_dh_auto_configure:
	./waf configure --gl --glesv2 --prefix=/usr

override_dh_auto_build:
	./waf

override_dh_auto_install:
	./waf install --destdir=debian/tmp

override_dh_auto_clean:
	./waf distclean

## glmark2 11.01

=== wscript ===
import commands
import subprocess
import os
import Options
import Scripting

out = 'build'
top = '.'

VERSION = '11.01'
APPNAME = 'glmark2'

def options(opt):
    opt.tool_options('compiler_cc')
    opt.tool_options('compiler_cxx')

    opt.add_option('--enable-gl', action='store_true', dest = 'gl',
                   default = False, help='build using OpenGL 2.0')
    opt.add_option('--enable-glesv2', action='store_true', dest = 'glesv2',
                   default = False, help='build using OpenGL ES 2.0')
    opt.add_option('--no-debug', action='store_false', dest = 'debug',
                   default = True, help='disable compiler debug information')
    opt.add_option('--no-opt', action='store_false', dest = 'opt',
                   default = True, help='disable compiler optimizations')
    opt.add_option('--data-path', action='store', dest = 'data_path',
                   help='the path to install the data to')

def configure(ctx):
    if not Options.options.gl and not Options.options.glesv2:
        ctx.fatal("You must configure using at least one of --enable-gl, --enable-glesv2")

    ctx.check_tool('compiler_cc')
    ctx.check_tool('compiler_cxx')

    # Check required headers
    req_headers = ['stdlib.h', 'string.h', 'unistd.h', 'fcntl.h']
    for header in req_headers:
        ctx.check_cxx(header_name = header, mandatory = True)

    # Check for required libs
    req_libs = [('m', 'm')]
    for (lib, uselib) in req_libs:
        ctx.check_cxx(lib = lib, uselib_store = uselib)

    # Check required functions
    req_funcs = [('memset', 'string.h', []) ,('sqrt', 'math.h', ['m'])]
    for func, header, uselib in req_funcs:
        ctx.check_cxx(function_name = func, header_name = header,
                      uselib = uselib, mandatory = True)

    # Check required packages
    req_pkgs = [('sdl', 'sdl')]
    for (pkg, uselib) in req_pkgs:
        ctx.check_cfg(package = pkg, uselib_store = uselib,
                      args = '--cflags --libs', mandatory = True)

    # Check optional packages
    opt_pkgs = [('gl', 'gl', Options.options.gl),
                ('egl', 'egl', Options.options.glesv2),
                ('glesv2', 'glesv2', Options.options.glesv2)]
    for (pkg, uselib, mandatory) in opt_pkgs:
        ctx.check_cfg(package = pkg, uselib_store = uselib,
                      args = '--cflags --libs', mandatory = mandatory)

    ctx.env.append_unique('CXXFLAGS', '-Wall -Wextra -fms-extensions'.split(' '))

    # Prepend -O# and -g flags so that they can be overriden by the
    # CFLAGS environment variable
    if Options.options.opt:
        ctx.env.prepend_value('CXXFLAGS', '-O2')
    if Options.options.debug:
        ctx.env.prepend_value('CXXFLAGS', '-g')

    if Options.options.data_path is None:
        Options.options.data_path = os.path.join(ctx.env.PREFIX, 'share/glmark2')

    ctx.env.append_unique('GLMARK_DATA_PATH', Options.options.data_path)
    ctx.env.append_unique('DEFINES', 'GLMARK_DATA_PATH="%s"' % Options.options.data_path)
    ctx.env.append_unique('DEFINES', 'GLMARK_VERSION="%s"' % VERSION)

    ctx.env.USE_GL = Options.options.gl
    ctx.env.USE_GLESv2 = Options.options.glesv2

    ctx.msg("Prefix", ctx.env.PREFIX, color = 'PINK')
    ctx.msg("Data path", Options.options.data_path, color = 'PINK')
    ctx.msg("Building GL2 version", "Yes" if ctx.env.USE_GL else "No",
            color = 'PINK')
    ctx.msg("Building GLESv2 version", "Yes" if ctx.env.USE_GLESv2 else "No",
            color = 'PINK')

def build(ctx):
    ctx.recurse('src')
    ctx.recurse('data')
    ctx.recurse('doc')

def dist(ctx):
    ctx.algo = 'tar.gz'

=== debian/changelog ===
glmark2 (11.01-0ubuntu1) natty; urgency=low

  * New upstream version 11.01 (LP: #707492).
  * debian/rules:
    - Use the new --enable-glesv2, --enable-gl configure flags.
  * debian/copyright:
    - Update copyright.
    - Change main source license to GPL-3+ (from GPL-3).
  * debian/control:
    - Change maintainer to "Linaro Graphics Working Group".
  * debian/watch:
    - Add watch file.

 -- Alexandros Frantzis <alexandros.frantzis@linaro.org>  Tue, 25 Jan 2011 17:53:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: glmark2
 Section: misc
 Priority: optional
-Maintainer: Linaro User Platforms <linaro-dev@lists.linaro.org>
+Maintainer: Linaro Graphics Working Group <linaro-dev@lists.linaro.org>
 Build-Depends: debhelper (>= 7.0.50~),
                python2.4 | python2.5 | python2.6 | python2.7,
                libsdl1.2-dev,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@ 

override_dh_auto_configure:
	./waf configure --enable-gl --enable-glesv2 --prefix=/usr

override_dh_auto_build:
	./waf

override_dh_auto_install:
	./waf install --destdir=debian/tmp

override_dh_auto_clean:
	./waf distclean

## glmark2 2011.09

=== wscript ===
--- 
+++ 
@@ -3,11 +3,12 @@
 import os
 import Options
 import Scripting
+from waflib import Context
 
 out = 'build'
 top = '.'
 
-VERSION = '11.01'
+VERSION = '2011.09'
 APPNAME = 'glmark2'
 
 def options(opt):
@@ -49,7 +50,7 @@
                       uselib = uselib, mandatory = True)
 
     # Check required packages
-    req_pkgs = [('sdl', 'sdl')]
+    req_pkgs = [('x11', 'x11'), ('libpng12', 'libpng12')]
     for (pkg, uselib) in req_pkgs:
         ctx.check_cfg(package = pkg, uselib_store = uselib,
                       args = '--cflags --libs', mandatory = True)
@@ -62,7 +63,7 @@
         ctx.check_cfg(package = pkg, uselib_store = uselib,
                       args = '--cflags --libs', mandatory = mandatory)
 
-    ctx.env.append_unique('CXXFLAGS', '-Wall -Wextra -fms-extensions'.split(' '))
+    ctx.env.append_unique('CXXFLAGS', '-Wall -Werror -Wextra -fms-extensions'.split(' '))
 
     # Prepend -O# and -g flags so that they can be overriden by the
     # CFLAGS environment variable
@@ -77,6 +78,7 @@
     ctx.env.append_unique('GLMARK_DATA_PATH', Options.options.data_path)
     ctx.env.append_unique('DEFINES', 'GLMARK_DATA_PATH="%s"' % Options.options.data_path)
     ctx.env.append_unique('DEFINES', 'GLMARK_VERSION="%s"' % VERSION)
+    ctx.env.GLMARK2_VERSION = VERSION
 
     ctx.env.USE_GL = Options.options.gl
     ctx.env.USE_GLESv2 = Options.options.glesv2
@@ -93,5 +95,42 @@
     ctx.recurse('data')
     ctx.recurse('doc')
 
-def dist(ctx):
-    ctx.algo = 'tar.gz'
+class Glmark2Dist(Context.Context):
+    """ Custom dist command that preserves symbolic links"""
+
+    cmd = "dist"
+
+    def execute(self):
+        self.recurse([os.path.dirname(Context.g_module.root_path)])
+        self.archive()
+
+    def get_files(self):
+        import fnmatch
+        files = []
+        excludes = ['*.bzr', '*~', './.*waf*', './build*', '*.swp', '*glmark2-*.tar.gz']
+        for (dirpath, dirnames, filenames) in os.walk(top):
+            names_to_remove = []
+            names = dirnames + filenames
+            for n in names:
+                for exclude in excludes:
+                    if fnmatch.fnmatch(os.path.join(dirpath, n), exclude):
+                        names_to_remove.append(n)
+                        break
+
+            for d in names_to_remove:
+                if d in dirnames:
+                    dirnames.remove(d)
+                if d in filenames:
+                    filenames.remove(d)
+
+            files.extend([os.path.join(dirpath, d) for d in dirnames])
+            files.extend([os.path.join(dirpath, f) for f in filenames])
+
+        return files
+
+    def archive(self):
+        import tarfile
+        tar = tarfile.open(APPNAME + '-' + VERSION + '.tar.gz', 'w:gz')
+        for f in self.get_files():
+            tar.add(f, arcname = APPNAME + '-' + VERSION + '/' + f, recursive = False)
+        tar.close()

=== src/libmatrix/Makefile ===
CXXFLAGS = -Wall -Werror -pedantic -O3
LIBMATRIX = libmatrix.a
LIBSRCS = mat.cc program.cc
LIBOBJS = $(LIBSRCS:.cc=.o)
TESTDIR = test
LIBMATRIX_TESTS = $(TESTDIR)/libmatrix_test
TESTSRCS = $(TESTDIR)/options.cc \
           $(TESTDIR)/const_vec_test.cc \
           $(TESTDIR)/inverse_test.cc \
           $(TESTDIR)/transpose_test.cc \
           $(TESTDIR)/libmatrix_test.cc
TESTOBJS = $(TESTSRCS:.cc=.o)

# Make sure to build both the library targets and the tests, and generate 
# a make failure if the tests don't pass.
default: $(LIBMATRIX) $(LIBMATRIX_TESTS) run_tests

# Main library targets here.
mat.o : mat.cc mat.h vec.h
program.o: program.cc program.h mat.h vec.h
libmatrix.a : mat.o mat.h stack.h vec.h program.o program.h
	$(AR) -r $@  $(LIBOBJS)

# Tests and execution targets here.
$(TESTDIR)/options.o: $(TESTDIR)/options.cc $(TESTDIR)/libmatrix_test.h
$(TESTDIR)/libmatrix_test.o: $(TESTDIR)/libmatrix_test.cc $(TESTDIR)/libmatrix_test.h $(TESTDIR)/inverse_test.h $(TESTDIR)/transpose_test.h
$(TESTDIR)/const_vec_test.o: $(TESTDIR)/const_vec_test.cc $(TESTDIR)/const_vec_test.h $(TESTDIR)/libmatrix_test.h vec.h
$(TESTDIR)/inverse_test.o: $(TESTDIR)/inverse_test.cc $(TESTDIR)/inverse_test.h $(TESTDIR)/libmatrix_test.h mat.h
$(TESTDIR)/transpose_test.o: $(TESTDIR)/transpose_test.cc $(TESTDIR)/transpose_test.h $(TESTDIR)/libmatrix_test.h mat.h
$(TESTDIR)/libmatrix_test: $(TESTOBJS) libmatrix.a
	$(CXX) -o $@ $^
run_tests: $(LIBMATRIX_TESTS)
	$(LIBMATRIX_TESTS)
clean :
	$(RM) $(LIBOBJS) $(TESTOBJS) $(LIBMATRIX) $(LIBMATRIX_TESTS)

=== debian/changelog ===
glmark2 (2011.09-0ubuntu1) oneiric; urgency=low

  * New upstream release 2011.09.
  * debian/control:
    - Start the description of the glmark2-data package with
      a lowercase letter.

 -- Alexandros Frantzis <alexandros.frantzis@linaro.org>  Thu, 22 Sep 2011 11:32:17 +0300

glmark2 (2011.08-0~linaro1) oneiric; urgency=low

  * New upstream release 2011.08.
  * debian/copyright:
    - Add copyright information for src/libpng.

 -- Alexandros Frantzis <alexandros.frantzis@linaro.org>  Fri, 19 Aug 2011 00:49:08 +0300

glmark2 (2011.07-0~linaro1) oneiric; urgency=low

  * New upstream release 2011.07.
  * debian/copyright:
    - Use a standalone license paragraph for the GPL3+ license text.

 -- Alexandros Frantzis <alexandros.frantzis@linaro.org>  Thu, 21 Jul 2011 12:19:15 +0300

glmark2 (2011.06-0~linaro1) oneiric; urgency=low

  * New upstream release 2011.06.
  * debian/copyright:
    - Added copyright information for src/libmatrix/*

 -- Alexandros Frantzis <alexandros.frantzis@linaro.org>  Fri, 24 Jun 2011 14:54:40 +0300

glmark2 (11.05-0~linaro1) natty; urgency=low

  * New upstream release 11.05.
  * debian/control:
    - Change maintainer to "Alexandros Frantzis".
    - Update Standards-Version to 3.9.2
    - Use python (>= 2.4) as a build-dependency instead of explicitly
      stating alternative python versions.

 -- Alexandros Frantzis <alexandros.frantzis@linaro.org>  Mon, 30 May 2011 14:07:36 +0300

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: glmark2
 Section: misc
 Priority: optional
-Maintainer: Linaro Graphics Working Group <linaro-dev@lists.linaro.org>
+Maintainer: Alexandros Frantzis <alexandros.frantzis@linaro.org>
 Build-Depends: debhelper (>= 7.0.50~),
-               python2.4 | python2.5 | python2.6 | python2.7,
-               libsdl1.2-dev,
+               python (>= 2.4),
+               pkg-config,
+               libx11-dev,
+               libpng12-dev,
                libgl1-mesa-dev | libgl1-dev,
                libegl1-mesa-dev | libegl1-dev,
                libgles2-mesa-dev | libgles2-dev
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: https://launchpad.net/glmark2
 
 Package: glmark2
@@ -38,5 +40,5 @@
 Package: glmark2-data
 Architecture: all
 Depends: ${misc:Depends}
-Description: Data files for the glmark2 OpenGL (ES) 2.0 benchmark
+Description: data files for the glmark2 OpenGL (ES) 2.0 benchmark
  This package contains the data files used by the glmark2 benchmark.

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 
 %:
-	dh $@ 
+	dh $@
 
 override_dh_auto_configure:
 	./waf configure --enable-gl --enable-glesv2 --prefix=/usr

## glmark2 2012.08

=== wscript ===
--- 
+++ 
@@ -8,10 +8,11 @@
 out = 'build'
 top = '.'
 
-VERSION = '2011.09'
+VERSION = '2012.08'
 APPNAME = 'glmark2'
 
 def options(opt):
+    opt.tool_options('gnu_dirs')
     opt.tool_options('compiler_cc')
     opt.tool_options('compiler_cxx')
 
@@ -24,22 +25,25 @@
     opt.add_option('--no-opt', action='store_false', dest = 'opt',
                    default = True, help='disable compiler optimizations')
     opt.add_option('--data-path', action='store', dest = 'data_path',
-                   help='the path to install the data to')
+                   help='path to main data (also see --data(root)dir)')
+    opt.add_option('--extras-path', action='store', dest = 'extras_path',
+                   help='path to additional data (models, shaders, textures)')
 
 def configure(ctx):
     if not Options.options.gl and not Options.options.glesv2:
         ctx.fatal("You must configure using at least one of --enable-gl, --enable-glesv2")
 
+    ctx.check_tool('gnu_dirs')
     ctx.check_tool('compiler_cc')
     ctx.check_tool('compiler_cxx')
 
     # Check required headers
-    req_headers = ['stdlib.h', 'string.h', 'unistd.h', 'fcntl.h']
+    req_headers = ['stdlib.h', 'string.h', 'unistd.h', 'stdint.h', 'stdio.h', 'jpeglib.h']
     for header in req_headers:
-        ctx.check_cxx(header_name = header, mandatory = True)
+        ctx.check_cxx(header_name = header, auto_add_header_name = True, mandatory = True)
 
     # Check for required libs
-    req_libs = [('m', 'm')]
+    req_libs = [('m', 'm'), ('jpeg', 'jpeg')]
     for (lib, uselib) in req_libs:
         ctx.check_cxx(lib = lib, uselib_store = uselib)
 
@@ -63,7 +67,7 @@
         ctx.check_cfg(package = pkg, uselib_store = uselib,
                       args = '--cflags --libs', mandatory = mandatory)
 
-    ctx.env.append_unique('CXXFLAGS', '-Wall -Werror -Wextra -fms-extensions'.split(' '))
+    ctx.env.append_unique('CXXFLAGS', '-Werror -Wall -Wextra -Wnon-virtual-dtor'.split(' '))
 
     # Prepend -O# and -g flags so that they can be overriden by the
     # CFLAGS environment variable
@@ -72,11 +76,19 @@
     if Options.options.debug:
         ctx.env.prepend_value('CXXFLAGS', '-g')
 
-    if Options.options.data_path is None:
-        Options.options.data_path = os.path.join(ctx.env.PREFIX, 'share/glmark2')
+    ctx.env.HAVE_EXTRAS = False
+    if Options.options.extras_path is not None:
+        ctx.env.HAVE_EXTRAS = True
+        ctx.env.append_unique('GLMARK_EXTRAS_PATH', Options.options.extras_path)
+        ctx.env.append_unique('DEFINES', 'GLMARK_EXTRAS_PATH="%s"' % Options.options.extras_path)
 
-    ctx.env.append_unique('GLMARK_DATA_PATH', Options.options.data_path)
-    ctx.env.append_unique('DEFINES', 'GLMARK_DATA_PATH="%s"' % Options.options.data_path)
+    if Options.options.data_path is not None:
+        data_path = Options.options.data_path 
+    else:
+        data_path = os.path.join(ctx.env.DATADIR, 'glmark2')
+
+    ctx.env.append_unique('GLMARK_DATA_PATH', data_path)
+    ctx.env.append_unique('DEFINES', 'GLMARK_DATA_PATH="%s"' % data_path)
     ctx.env.append_unique('DEFINES', 'GLMARK_VERSION="%s"' % VERSION)
     ctx.env.GLMARK2_VERSION = VERSION
 
@@ -84,7 +96,11 @@
     ctx.env.USE_GLESv2 = Options.options.glesv2
 
     ctx.msg("Prefix", ctx.env.PREFIX, color = 'PINK')
-    ctx.msg("Data path", Options.options.data_path, color = 'PINK')
+    ctx.msg("Data path", data_path, color = 'PINK')
+    ctx.msg("Including extras", "Yes" if ctx.env.HAVE_EXTRAS else "No",
+            color = 'PINK');
+    if ctx.env.HAVE_EXTRAS:
+        ctx.msg("Extras path", Options.options.extras_path, color = 'PINK')
     ctx.msg("Building GL2 version", "Yes" if ctx.env.USE_GL else "No",
             color = 'PINK')
     ctx.msg("Building GLESv2 version", "Yes" if ctx.env.USE_GLESv2 else "No",
@@ -107,7 +123,7 @@
     def get_files(self):
         import fnmatch
         files = []
-        excludes = ['*.bzr', '*~', './.*waf*', './build*', '*.swp', '*glmark2-*.tar.gz']
+        excludes = ['*.bzr', '*~', './.*waf*', './build*', '*.swp', '*.pyc', '*glmark2-*.tar.gz']
         for (dirpath, dirnames, filenames) in os.walk(top):
             names_to_remove = []
             names = dirnames + filenames

=== src/libpng/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.3)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

if(UNIX AND NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING 
      "Choose the type of build, options are:
         None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used)
         Debug
         Release
         RelWithDebInfo
         MinSizeRel.")
endif()

project(libpng C)
enable_testing()

# Copyright (C) 2007-2010 Glenn Randers-Pehrson

# This code is released under the libpng license.
# For conditions of distribution and use, see the disclaimer
# and license in png.h

set(PNGLIB_MAJOR 1)
set(PNGLIB_MINOR 2)
set(PNGLIB_RELEASE 46)
set(PNGLIB_NAME libpng${PNGLIB_MAJOR}${PNGLIB_MINOR})
set(PNGLIB_VERSION ${PNGLIB_MAJOR}.${PNGLIB_MINOR}.${PNGLIB_RELEASE})

# needed packages
find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIR})

if(NOT WIN32)
  find_library(M_LIBRARY
    NAMES m
    PATHS /usr/lib /usr/local/lib
  )
  if(NOT M_LIBRARY)
    message(STATUS
      "math library 'libm' not found - floating point support disabled")
  endif()
else()
  # not needed on windows
  set(M_LIBRARY "")
endif()

# COMMAND LINE OPTIONS
if(DEFINED PNG_SHARED)
  option(PNG_SHARED "Build shared lib" ${PNG_SHARED})
else()
  option(PNG_SHARED "Build shared lib" ON)
endif()
if(DEFINED PNG_STATIC)
  option(PNG_STATIC "Build static lib" ${PNG_STATIC})
else()
  option(PNG_STATIC "Build static lib" ON)
endif()

if(MINGW)
  option(PNG_TESTS  "Build pngtest" NO)
else()
  option(PNG_TESTS  "Build pngtest" YES)
endif()

option(PNG_NO_CONSOLE_IO "FIXME" YES)
option(PNG_NO_STDIO      "FIXME" YES)
option(PNG_DEBUG         "Build with debug output" NO)
option(PNGARG            "FIXME" YES)
#TODO:
# PNG_CONSOLE_IO_SUPPORTED

# maybe needs improving, but currently I don't know when we can enable what :)
set(png_asm_tmp "OFF")
if(NOT WIN32)
  find_program(uname_executable NAMES uname PATHS /bin /usr/bin /usr/local/bin)
  if(uname_executable)
    exec_program(${uname_executable}
                 ARGS --machine OUTPUT_VARIABLE uname_output)
    if("uname_output" MATCHES "^.*i[1-9]86.*$")
      set(png_asm_tmp "ON")
    else("uname_output" MATCHES "^.*i[1-9]86.*$")
      set(png_asm_tmp "OFF")
    endif("uname_output" MATCHES "^.*i[1-9]86.*$")
  endif(uname_executable)
else()
  # this env var is normally only set on win64
  set(TEXT "ProgramFiles(x86)")
  if("$ENV{${TEXT}}" STREQUAL "")
    set(png_asm_tmp "ON")
  endif("$ENV{${TEXT}}" STREQUAL "")
endif()

# SET LIBNAME
set(PNG_LIB_NAME png${PNGLIB_MAJOR}${PNGLIB_MINOR})

# to distinguish between debug and release lib
set(CMAKE_DEBUG_POSTFIX "d")


# OUR SOURCES
set(libpng_sources
  png.h
  pngconf.h
  png.c
  pngerror.c
  pngget.c
  pngmem.c
  pngpread.c
  pngread.c
  pngrio.c
  pngrtran.c
  pngrutil.c
  pngset.c
  pngtrans.c
  pngwio.c
  pngwrite.c
  pngwtran.c
  pngwutil.c
)
set(pngtest_sources
  pngtest.c
)
# SOME NEEDED DEFINITIONS

add_definitions(-DPNG_CONFIGURE_LIBPNG)

if(_AIX)
  add_definitions(-D_ALL_SOURCE)
endif(_AIX)

if(MSVC)
  add_definitions(-DPNG_NO_MODULEDEF -D_CRT_SECURE_NO_DEPRECATE)
endif(MSVC)

if(PNG_SHARED OR  NOT MSVC)
  #if building msvc static this has NOT to be defined
  add_definitions(-DZLIB_DLL)
endif()

add_definitions(-DLIBPNG_NO_MMX)
add_definitions(-DPNG_NO_MMX_CODE)


if(PNG_CONSOLE_IO_SUPPORTED)
  add_definitions(-DPNG_CONSOLE_IO_SUPPORTED)
endif()

if(PNG_NO_CONSOLE_IO)
  add_definitions(-DPNG_NO_CONSOLE_IO)
endif()

if(PNG_NO_STDIO)
  add_definitions(-DPNG_NO_STDIO)
endif()

if(PNG_DEBUG)
  add_definitions(-DPNG_DEBUG)
endif()

if(NOT M_LIBRARY AND NOT WIN32)
  add_definitions(-DPNG_NO_FLOATING_POINT_SUPPORTED)
endif()

# NOW BUILD OUR TARGET
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${ZLIB_INCLUDE_DIR})

if(PNG_SHARED)
  add_library(${PNG_LIB_NAME} SHARED ${libpng_sources})
  if(MSVC)
    # msvc does not append 'lib' - do it here to have consistent name
    set_target_properties(${PNG_LIB_NAME} PROPERTIES PREFIX "lib")
  endif()
  target_link_libraries(${PNG_LIB_NAME} ${ZLIB_LIBRARY} ${M_LIBRARY})
endif()

if(PNG_STATIC)
# does not work without changing name
  set(PNG_LIB_NAME_STATIC ${PNG_LIB_NAME}_static)
  add_library(${PNG_LIB_NAME_STATIC} STATIC ${libpng_sources})
  if(MSVC)
    # msvc does not append 'lib' - do it here to have consistent name
    set_target_properties(${PNG_LIB_NAME_STATIC} PROPERTIES PREFIX "lib")
  endif()
endif()


if(PNG_SHARED AND WIN32)
  set_target_properties(${PNG_LIB_NAME} PROPERTIES DEFINE_SYMBOL PNG_BUILD_DLL)
endif()

if(PNG_TESTS AND PNG_SHARED)
  # does not work with msvc due to png_lib_ver issue
  add_executable(pngtest ${pngtest_sources})
  target_link_libraries(pngtest ${PNG_LIB_NAME})
  add_test(pngtest pngtest ${CMAKE_CURRENT_SOURCE_DIR}/pngtest.png)
endif()


# CREATE PKGCONFIG FILES
# we use the same files like ./configure, so we have to set its vars
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(libdir      ${CMAKE_INSTALL_PREFIX}/lib)
set(includedir  ${CMAKE_INSTALL_PREFIX}/include)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/libpng.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/libpng.pc)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/libpng-config.in
  ${CMAKE_CURRENT_BINARY_DIR}/libpng-config)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/libpng.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/${PNGLIB_NAME}.pc)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/libpng-config.in
  ${CMAKE_CURRENT_BINARY_DIR}/${PNGLIB_NAME}-config)

# SET UP LINKS
if(PNG_SHARED)
  set_target_properties(${PNG_LIB_NAME} PROPERTIES
#   VERSION 0.${PNGLIB_RELEASE}.1.2.46
    VERSION 0.${PNGLIB_RELEASE}.0
    SOVERSION 0
    CLEAN_DIRECT_OUTPUT 1)
endif()
if(PNG_STATIC)
  if(NOT WIN32)
    # that's uncool on win32 - it overwrites our static import lib...
    set_target_properties(${PNG_LIB_NAME_STATIC} PROPERTIES
      OUTPUT_NAME ${PNG_LIB_NAME}
      CLEAN_DIRECT_OUTPUT 1)
  endif()
endif()

# INSTALL
if(NOT SKIP_INSTALL_LIBRARIES AND NOT SKIP_INSTALL_ALL )
  if(PNG_SHARED)
    install(TARGETS ${PNG_LIB_NAME}
            RUNTIME DESTINATION bin
            LIBRARY DESTINATION lib
            ARCHIVE DESTINATION lib)
  endif()
  if(PNG_STATIC)
    install(TARGETS ${PNG_LIB_NAME_STATIC}
            LIBRARY DESTINATION lib
            ARCHIVE DESTINATION lib)
  endif()
endif()

if(NOT SKIP_INSTALL_HEADERS AND NOT SKIP_INSTALL_ALL )
  install(FILES png.h pngconf.h         DESTINATION include)
  install(FILES png.h pngconf.h         DESTINATION include/${PNGLIB_NAME})
endif()
if(NOT SKIP_INSTALL_EXECUTABLES AND NOT SKIP_INSTALL_ALL )
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/libpng-config DESTINATION bin)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${PNGLIB_NAME}-config
          DESTINATION bin)
endif()
if(NOT SKIP_INSTALL_FILES AND NOT SKIP_INSTALL_ALL )
  # Install man pages
  install(FILES libpng.3 libpngpf.3             DESTINATION man/man3)
  install(FILES png.5                           DESTINATION man/man5)
  # Install pkg-config files
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpng.pc
          DESTINATION lib/pkgconfig)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpng-config
          DESTINATION bin)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PNGLIB_NAME}.pc
          DESTINATION lib/pkgconfig)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PNGLIB_NAME}-config
          DESTINATION bin)
endif()

# what's with libpng.txt and all the extra files?


# UNINSTALL
# do we need this?


# DIST
# do we need this?

# to create msvc import lib for mingw compiled shared lib
# pexports libpng.dll > libpng.def
# lib /def:libpng.def /machine:x86

=== debian/changelog ===
glmark2 (2012.08-0ubuntu2) quantal; urgency=low

  * debian/patches/update-handle-api-change-glx_ext_swap_control.patch:
    - Fixing FTBFS with latest mesa due api change (LP: #1040895)

 -- Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>  Sat, 25 Aug 2012 23:35:30 -0300

glmark2 (2012.08-0ubuntu1) quantal; urgency=low

  * New upstream release 2012.08 (LP: #1039736)
    - Avoid crashing if gl used is not >= 2.0 (LP: #842279)
  * Bumping dh compatibility level to v9
  * debian/control:
    - Update Standards-Version to 3.9.3.
    - Add libjpeg-dev build dependency.
    - Use libegl1-x11-dev as an build-dep alternative instead of libegl1-dev.
    - Update description of glmark2-data binary package.
  * debian/copyright:
    - Refresh copyright based on the current upstrem version
  * debian/rules:
    - Clean compiled python code from unpacked waflib/ directory, as
      described in http://wiki.debian.org/UnpackWaf

 -- Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>  Tue, 21 Aug 2012 15:38:09 -0300

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,18 @@
 Source: glmark2
 Section: misc
 Priority: optional
-Maintainer: Alexandros Frantzis <alexandros.frantzis@linaro.org>
-Build-Depends: debhelper (>= 7.0.50~),
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Alexandros Frantzis <alexandros.frantzis@linaro.org>
+Build-Depends: debhelper (>= 9),
                python (>= 2.4),
                pkg-config,
                libx11-dev,
+               libjpeg-dev,
                libpng12-dev,
                libgl1-mesa-dev | libgl1-dev,
-               libegl1-mesa-dev | libegl1-dev,
+               libegl1-mesa-dev | libegl1-x11-dev,
                libgles2-mesa-dev | libgles2-dev
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: https://launchpad.net/glmark2
 
 Package: glmark2
@@ -41,4 +43,8 @@
 Architecture: all
 Depends: ${misc:Depends}
 Description: data files for the glmark2 OpenGL (ES) 2.0 benchmark
+ A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
+ API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
+ arrays, VBOs, texturing and shaders.
+ .
  This package contains the data files used by the glmark2 benchmark.

=== debian/rules ===
--- 
+++ 
@@ -22,3 +22,6 @@
 
 override_dh_auto_clean:
 	./waf distclean
+	# Clean compiled python code from unpacked waflib/ directory, as
+	# described in http://wiki.debian.org/UnpackWaf .
+	-find waflib -name "*.pyc" -delete

=== debian/watch ===
version=3
http://launchpad.net/glmark2/+download http://launchpad.net/glmark2/trunk/.*/\+download/glmark2-(.*)\.tar\.gz

## glmark2 2014.03

=== wscript ===
--- 
+++ 
@@ -8,18 +8,44 @@
 out = 'build'
 top = '.'
 
-VERSION = '2012.08'
+VERSION = '2014.03'
 APPNAME = 'glmark2'
+
+FLAVORS = {
+    'x11-gl' : 'glmark2',
+    'x11-glesv2' : 'glmark2-es2',
+    'drm-gl' : 'glmark2-drm',
+    'drm-glesv2' : 'glmark2-es2-drm',
+    'mir-gl' : 'glmark2-mir',
+    'mir-glesv2' : 'glmark2-es2-mir',
+    'wayland-gl' : 'glmark2-wayland',
+    'wayland-glesv2' : 'glmark2-es2-wayland'
+}
+FLAVORS_STR = ", ".join(FLAVORS.keys())
+
+def option_list_cb(option, opt, value, parser):
+    value = value.split(',')
+    setattr(parser.values, option.dest, value)
+
+def list_contains(lst, token):
+    for e in lst:
+        if token.endswith('$'):
+            if e.endswith(token[:-1]): return True
+        elif token in e: return True
+
+    return False
 
 def options(opt):
     opt.tool_options('gnu_dirs')
     opt.tool_options('compiler_cc')
     opt.tool_options('compiler_cxx')
 
-    opt.add_option('--enable-gl', action='store_true', dest = 'gl',
-                   default = False, help='build using OpenGL 2.0')
-    opt.add_option('--enable-glesv2', action='store_true', dest = 'glesv2',
-                   default = False, help='build using OpenGL ES 2.0')
+    opt.add_option('--with-flavors', type = 'string', action='callback',
+                   callback=option_list_cb,
+                   dest = 'flavors',
+                   help = "a list of flavors to build (%s, all)" % FLAVORS_STR)
+    opt.parser.set_default('flavors', [])
+
     opt.add_option('--no-debug', action='store_false', dest = 'debug',
                    default = True, help='disable compiler debug information')
     opt.add_option('--no-opt', action='store_false', dest = 'opt',
@@ -30,8 +56,22 @@
                    help='path to additional data (models, shaders, textures)')
 
 def configure(ctx):
-    if not Options.options.gl and not Options.options.glesv2:
-        ctx.fatal("You must configure using at least one of --enable-gl, --enable-glesv2")
+    # Special 'all' flavor
+    if 'all' in Options.options.flavors:
+        Options.options.flavors = list(set(Options.options.flavors) | set(FLAVORS.keys()))
+        Options.options.flavors.remove('all')
+
+    # Ensure the flavors are valid
+    for flavor in Options.options.flavors:
+       if flavor not in FLAVORS:
+            ctx.fatal('Unknown flavor: %s. Supported flavors are %s' % (flavor, FLAVORS_STR))
+
+    if not Options.options.flavors:
+        ctx.fatal('You need to select at least one flavor. Supported flavors are %s' % FLAVORS_STR)
+
+    for flavor in FLAVORS:
+        if flavor in Options.options.flavors:
+            ctx.env["FLAVOR_%s" % flavor.upper().replace('-','_')] = FLAVORS[flavor]
 
     ctx.check_tool('gnu_dirs')
     ctx.check_tool('compiler_cc')
@@ -53,16 +93,32 @@
         ctx.check_cxx(function_name = func, header_name = header,
                       uselib = uselib, mandatory = True)
 
-    # Check required packages
-    req_pkgs = [('x11', 'x11'), ('libpng12', 'libpng12')]
-    for (pkg, uselib) in req_pkgs:
-        ctx.check_cfg(package = pkg, uselib_store = uselib,
-                      args = '--cflags --libs', mandatory = True)
+    # Check for a supported version of libpng
+    supp_png_pkgs = (('libpng12', '1.2'), ('libpng15', '1.5'),)
+    have_png = False
+    for (pkg, atleast) in supp_png_pkgs:
+        try:
+            pkg_ver = ctx.check_cfg(package=pkg, uselib_store='libpng', atleast_version=atleast,
+                                    args = ['--cflags', '--libs'])
+        except:
+            continue
+        else:
+            have_png = True
+            break
+
+    if not have_png:
+        ctx.fatal('You need to install a supported version of libpng: ' + str(supp_png_pkgs))
 
     # Check optional packages
-    opt_pkgs = [('gl', 'gl', Options.options.gl),
-                ('egl', 'egl', Options.options.glesv2),
-                ('glesv2', 'glesv2', Options.options.glesv2)]
+    opt_pkgs = [('x11', 'x11', list_contains(Options.options.flavors, 'x11')),
+                ('gl', 'gl', list_contains(Options.options.flavors, 'gl$')),
+                ('egl', 'egl', list_contains(Options.options.flavors, 'glesv2$')),
+                ('glesv2', 'glesv2', list_contains(Options.options.flavors, 'glesv2$')),
+                ('libdrm','drm', list_contains(Options.options.flavors, 'drm')),
+                ('gbm','gbm', list_contains(Options.options.flavors, 'drm')),
+                ('mirclient','mirclient', list_contains(Options.options.flavors, 'mir')),
+                ('wayland-client','wayland-client', list_contains(Options.options.flavors, 'wayland')),
+                ('wayland-egl','wayland-egl', list_contains(Options.options.flavors, 'wayland'))]
     for (pkg, uselib, mandatory) in opt_pkgs:
         ctx.check_cfg(package = pkg, uselib_store = uselib,
                       args = '--cflags --libs', mandatory = mandatory)
@@ -92,19 +148,13 @@
     ctx.env.append_unique('DEFINES', 'GLMARK_VERSION="%s"' % VERSION)
     ctx.env.GLMARK2_VERSION = VERSION
 
-    ctx.env.USE_GL = Options.options.gl
-    ctx.env.USE_GLESv2 = Options.options.glesv2
-
     ctx.msg("Prefix", ctx.env.PREFIX, color = 'PINK')
     ctx.msg("Data path", data_path, color = 'PINK')
     ctx.msg("Including extras", "Yes" if ctx.env.HAVE_EXTRAS else "No",
             color = 'PINK');
     if ctx.env.HAVE_EXTRAS:
         ctx.msg("Extras path", Options.options.extras_path, color = 'PINK')
-    ctx.msg("Building GL2 version", "Yes" if ctx.env.USE_GL else "No",
-            color = 'PINK')
-    ctx.msg("Building GLESv2 version", "Yes" if ctx.env.USE_GLESv2 else "No",
-            color = 'PINK')
+    ctx.msg("Building flavors", Options.options.flavors)
 
 def build(ctx):
     ctx.recurse('src')

=== debian/changelog ===
glmark2 (2014.03-0ubuntu3) utopic; urgency=medium

  * A no-change rebuild against latest Mir.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Wed, 02 Jul 2014 18:32:25 +0200

glmark2 (2014.03-0ubuntu2) utopic; urgency=medium

  * Only build the mir variant on amd64, arm64, armhf, and i386.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 29 May 2014 09:37:16 +0200

glmark2 (2014.03-0ubuntu1) utopic; urgency=medium

  [ Alexandros Frantzis ]
  * New upstream release 2014.03.
  * debian/control:
    - Update Standards-Version to 3.9.5.
    - Add binary packages for wayland, mir and drm variants.
  * debian/rules:
    - Build wayland, mir and drm variants.
    - Programatically create .install and .manpages files for
      variant binary packages.

 -- Ricardo Salveti de Araujo <ricardo.salveti@canonical.com>  Thu, 08 May 2014 23:42:01 -0300

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,12 @@
                libpng12-dev,
                libgl1-mesa-dev | libgl1-dev,
                libegl1-mesa-dev | libegl1-x11-dev,
-               libgles2-mesa-dev | libgles2-dev
-Standards-Version: 3.9.3
+               libgles2-mesa-dev | libgles2-dev,
+               libwayland-dev,
+               libmirclient-dev [amd64 arm64 armhf i386],
+               libdrm-dev,
+               libgbm-dev,
+Standards-Version: 3.9.5
 Homepage: https://launchpad.net/glmark2
 
 Package: glmark2
@@ -20,24 +24,96 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          glmark2-data (= ${source:Version})
-Description: OpenGL (ES) 2.0 benchmark
+Description: OpenGL 2.0 X11 benchmark
  A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
  API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
  arrays, VBOs, texturing and shaders.
  .
- This package contains the OpenGL 2.0 variant of the benchmark.
+ This package contains the OpenGL 2.0 variant of the benchmark for X11.
 
 Package: glmark2-es2
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          glmark2-data (= ${source:Version})
-Description: OpenGL (ES) 2.0 benchmark
+Description: OpenGL ES 2.0 X11 benchmark
  A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
  API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
  arrays, VBOs, texturing and shaders.
  .
- This package contains the OpenGL ES 2.0 variant of the benchmark.
+ This package contains the OpenGL ES 2.0 variant of the benchmark for X11.
+
+Package: glmark2-wayland
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         glmark2-data (= ${source:Version})
+Description: OpenGL 2.0 Wayland benchmark
+ A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
+ API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
+ arrays, VBOs, texturing and shaders.
+ .
+ This package contains the OpenGL 2.0 variant of the benchmark for Wayland.
+
+Package: glmark2-es2-wayland
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         glmark2-data (= ${source:Version})
+Description: OpenGL ES 2.0 Wayland benchmark
+ A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
+ API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
+ arrays, VBOs, texturing and shaders.
+ .
+ This package contains the OpenGL ES 2.0 variant of the benchmark for Wayland.
+
+Package: glmark2-mir
+Architecture: amd64 arm64 armhf i386
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         glmark2-data (= ${source:Version})
+Description: OpenGL 2.0 Mir benchmark
+ A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
+ API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
+ arrays, VBOs, texturing and shaders.
+ .
+ This package contains the OpenGL 2.0 variant of the benchmark for Mir.
+
+Package: glmark2-es2-mir
+Architecture: amd64 arm64 armhf i386
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         glmark2-data (= ${source:Version})
+Description: OpenGL ES 2.0 Mir benchmark
+ A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
+ API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
+ arrays, VBOs, texturing and shaders.
+ .
+ This package contains the OpenGL ES 2.0 variant of the benchmark for Mir.
+
+Package: glmark2-drm
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         glmark2-data (= ${source:Version})
+Description: OpenGL 2.0 DRM benchmark
+ A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
+ API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
+ arrays, VBOs, texturing and shaders.
+ .
+ This package contains the OpenGL 2.0 variant of the benchmark for DRM.
+
+Package: glmark2-es2-drm
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         glmark2-data (= ${source:Version})
+Description: OpenGL ES 2.0 DRM benchmark
+ A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
+ API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
+ arrays, VBOs, texturing and shaders.
+ .
+ This package contains the OpenGL ES 2.0 variant of the benchmark for DRM.
 
 Package: glmark2-data
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -7,12 +7,19 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
+DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
+
+FLAVORS:=x11-gl,x11-glesv2,wayland-gl,wayland-glesv2
+ifneq (,$(filter amd64 arm64 armhf i386,$(DEB_HOST_ARCH)))
+FLAVORS:=$(FLAVORS),mir-gl,mir-glesv2
+endif
+FLAVORS:=$(FLAVORS),drm-gl,drm-glesv2
 
 %:
 	dh $@
 
 override_dh_auto_configure:
-	./waf configure --enable-gl --enable-glesv2 --prefix=/usr
+	./waf configure --with-flavors=$(FLAVORS) --prefix=/usr
 
 override_dh_auto_build:
 	./waf
@@ -25,3 +32,11 @@
 	# Clean compiled python code from unpacked waflib/ directory, as
 	# described in http://wiki.debian.org/UnpackWaf .
 	-find waflib -name "*.pyc" -delete
+
+override_dh_install:
+	sh debian/create_package_install_files.sh
+	dh_install
+
+override_dh_installman:
+	sh debian/create_package_manpages_files.sh
+	dh_installman
